# CSVDataInput (ARX Developer Documentation)

org.deidentifier.arx.io

## Class CSVDataInput

- java.lang.Object
- - org.deidentifier.arx.io.CSVDataInput

-     public class CSVDataInput
      extends java.lang.Object

  This class implements a reader for CSV encoded information.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.
    `CSVDataInput(java.io.File file, java.nio.charset.Charset charset, CSVSyntax config, DataType<org.apache.poi.ss.formula.functions.T>[] datatype)` Instatiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.
    `CSVDataInput(java.io.InputStream stream, java.nio.charset.Charset charset, CSVSyntax config, DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)` Instantiate.
    `CSVDataInput(java.io.Reader reader, char delimiter, char quote, char escape, char[] linebreak, DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.
    `CSVDataInput(java.lang.String filename, java.nio.charset.Charset charset, CSVSyntax config, DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)` Instantiate.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the reader.
    `java.util.Iterator<java.lang.String[]>` | `iterator()` Returns an iterator.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      char delimiter)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape,
                      char[] linebreak)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      CSVSyntax config)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.File file,
                      java.nio.charset.Charset charset,
                      CSVSyntax config,
                      DataType<org.apache.poi.ss.formula.functions.T>[] datatype)
                       throws java.io.IOException

      Instatiate.
      Parameters:
        `file` -
        `config` -
        `datatype` -
      Throws:
        `java.io.IOException`

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      char delimiter)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape,
                      char[] linebreak)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      CSVSyntax config)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.io.InputStream stream,
                      java.nio.charset.Charset charset,
                      CSVSyntax config,
                      DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` -
        `config` -
        `datatypes` -
      Throws:
        `java.io.IOException`

    - #### CSVDataInput

          public CSVDataInput(java.io.Reader reader,
                      char delimiter,
                      char quote,
                      char escape,
                      char[] linebreak,
                      DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `reader` - the reader
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      char delimiter)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      char delimiter,
                      char quote,
                      char escape,
                      char[] linebreak)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      CSVSyntax config)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVDataInput

          public CSVDataInput(java.lang.String filename,
                      java.nio.charset.Charset charset,
                      CSVSyntax config,
                      DataType<org.apache.poi.ss.formula.functions.T>[] datatypes)
                       throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` -
        `config` -
        `datatypes` -
      Throws:
        `java.io.IOException`

  - ### Method Detail

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the reader.
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### iterator

          public java.util.Iterator<java.lang.String[]> iterator()

      Returns an iterator.
      Returns:
        the iterator